'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = futureMiddleware;

var _fluxStandardAction = require('flux-standard-action');

function isFuture(val) {
  return val && typeof val.fork === 'function';
}

function futureMiddleware(_ref) {
  var dispatch = _ref.dispatch;

  return function (next) {
    return function (action) {
      if (!(0, _fluxStandardAction.isFSA)(action)) {
        return isFuture(action) ? action.fork(function (error) {
          return error.type ? dispatch(error) : next(action);
        }, dispatch) : next(action);
      }

      return isFuture(action.payload) ? action.payload.fork(function (error) {
        return dispatch(_extends({}, action, { payload: error, error: true }));
      }, function (result) {
        return dispatch(_extends({}, action, { payload: result }));
      }) : next(action);
    };
  };
}